<template>
	<view class="index">
		<scroll-view scroll-y="true" @scrolltolower="scrolltolower">
			<view class="list">
				<view class="item" @tap="toDetail(item)" v-for="item in workList" :key="item.id">
					<view class="top">
						岗位名称:{{item.postName}}
						<DictType :types="qgzx_stu_post_status" :type="item.applyStatus" />
					</view>
					<view class="content">
						<view>设岗部门：{{item.deptName}}</view>
						<view>工作日期：{{item.workDate}}</view>
						<view>工作时长(单位:小时)：{{item.workTime}}</view>
					</view>
					<view class="bottom" v-if="item.applyStatus == '0' || item.applyStatus == '1'" @tap.stop="onCancelApply(item.id)">
						<button>取消申请</button>
					</view>
				</view>
			</view>
			<view class="empty" v-if="workList.length==0&&topLoading==false">
				<image src="@/static/empty.png" mode="widthFix"></image>
				暂时没有数据
			</view>
			<view class="loading-more-top" v-if="topLoading">
				<uni-load-more style="padding-top: 90px;" status="loading" />
			</view>
			<view class="loading-more" v-if="loading">
				<uni-load-more status="loading" />
			</view>
			<view class="no-more" v-if="!loading&&workList.length!=0">
				到底啦~~
			</view>
		</scroll-view>
		<view class="add" @tap="add">
			+
		</view>
	</view>
</template>

<script>
	import Nav from "@/components/navs/navs.vue";
	import DictType from "@/components/dict-type/dict-type.vue";
	import DictStatus from "@/components/dict-status/dict-status.vue";
	import {
		listOwnApply as getList,
		cancelApply
	} from "@/api/workStudy/workStudy";
	import {
		getDicts,
	} from '@/api/system/dict/data.js';
	export default {
		components: {
			DictType,
			DictStatus
		},
		data() {
			return {
				workList: [],
				loading: false,
				topLoading: true,
				rt_penalty_type: [],
				qgzx_stu_post_status: [],
				queryParams: {
					pageNum: 1,
					pageSize: 10,
					penaltyStatus: ""
				},
			}
		},
		onLoad() {
			this.getList();
			this.get_penalty_type();
			this.get_penalty_status();
		},
		methods: {
			add() {
				uni.navigateTo({
					url: "./add"
				})
			},
			onCancelApply(id) {
				uni.showModal({
					title: "确定取消申请吗?",
					success: async (bool) => {
						if (bool.confirm) {
							let res = await cancelApply(id);
							if (res.code == 200) {
								uni.showToast({
									title:"取消成功"
								})
								this.getList();
							}
						}
					}
				})
			},
			scrolltolower() {
				if (this.queryParams.pageNum < this.totalPages) {
					this.queryParams.pageNum++;
					this.loading = true;
					setTimeout(() => {
						this.getList()
					}, 1000)
				} else {

				}
			},
			toDetail(item) {
				uni.navigateTo({
					url: "./detail?detailData="+JSON.stringify(item)
				})
			},
			async getList() {
				console.log(this.queryParams.pageNum);
				let res = await getList(this.queryParams);
				if (res.code == 200) {
					this.loading = false;
					if (this.queryParams.pageNum == 1) {
						this.workList = res.rows; // 如果是第一页，直接显示新数据
					} else {
						this.workList = this.workList.concat(res.rows); // 否则追加新数据到列表中
					}
					this.totalPages = Math.ceil(res.total / this.queryParams.pageSize);
					this.topLoading = false;

				}
			},
			async get_penalty_type() {
				let res = await getDicts('rt_penalty_type');
				this.rt_penalty_type = res.data;
			},
			async get_penalty_status() {
				let res = await getDicts('qgzx_stu_post_status');
				this.qgzx_stu_post_status = res.data;
			},
		}
	}
</script>

<style scoped lang="scss">
	.index {
		background-color: #F5F5F7;

		scroll-view {
			height: calc(100vh - 10px);

			.no-more {
				text-align: center;
				color: gray;
				padding-bottom: 10px;
			}

			.empty {
				display: flex;
				flex-direction: column;
				align-items: center;
				margin-top: 200rpx;
				color: #9E9E9E;
				font-size: 36rpx;

				image {
					width: 250rpx;
					margin-bottom: 50rpx;
				}
			}
		}

		.list {
			padding: 20rpx 40rpx 15rpx 40rpx;

			.item {
				background-color: white;
				margin-bottom: 20rpx;
				padding: 40rpx 40rpx 80rpx;
				border-radius: 16px;
				border-bottom-right-radius: 0;
				position: relative;

				.top {
					display: flex;
					justify-content: space-between;
					border-bottom: 1px solid #F5F5F7;
					padding-bottom: 20rpx;

					.uni-icons {
						opacity: 0.5;
					}
				}

				.content {
					padding-top: 20rpx;

					.level {
						display: flex;

					}

					&>view:not(:last-child) {
						margin-bottom: 15rpx;

						.progress {
							color: #1890FF;
						}
					}

					.status {
						position: absolute;
						bottom: 0;
						right: 0;
						color: white;

						.status-text {
							position: absolute;
							bottom: 15px;
							right: 8%;
							font-size: 35rpx;
						}

						.triangle-right {
							width: 0;
							height: 0;
							/* 上边框设置为透明 */
							border-left: 120px solid transparent;
						}

						&.submit {
							color: #202020;

							.triangle-right {
								/* 左边框设置为与文本相同的颜色 */
								border-bottom: 100px solid #D7D7D7;
							}
						}

						&.agree {
							.triangle-right {
								/* 左边框设置为与文本相同的颜色 */
								border-bottom: 100px solid #2FB15B;
							}
						}

						&.refuse {
							.triangle-right {
								/* 左边框设置为与文本相同的颜色 */
								border-bottom: 100px solid #FF759F;
							}
						}
					}
				}

				.bottom {
					position: absolute;
					right: 0;
					bottom: 10px;

					button {
						margin: 0;
						background-color: transparent;
						margin-right: 10px;
						padding: 0px 10px;
						height: 32px;
						line-height: 32px;
						font-size: 28rpx;
						width: 160rpx;
						border: 1px solid #007aff;
						color: #007aff;
					}
				}
			}
		}

		.add {
			background-color: #1890FF;
			width: 90rpx;
			height: 90rpx;
			border-radius: 50%;
			color: white;
			display: flex;
			justify-content: center;
			align-items: center;
			font-size: 60rpx;
			position: fixed;
			bottom: 50px;
			right: 25px;
		}
	}
</style>
